package capsule;

import stat.*;
import node.*;

public class BandwidthMeter extends Meter {
    // Bandwidth

    long byteCounter=0;
    long last=0;

    long byteSum=0;
    long first=-1;
    long now=0;
 
    public BandwidthMeter(MeterAgent a) {
	initAgent(a); 
    }

    public void packetArrival(IPPacket p) {
	//long now= System.currentTimeMillis(); // was for testing
	if(first<0) { // Init. Ignore size of the first packet
	    first=p.timeStamp; 
	    last=first;
	    return;
	}
	now=p.timeStamp;
	long dt=(now-last);
	int payloadLen=p.len();// add header also?
	byteSum+=payloadLen;
	byteCounter+=payloadLen; 
	if (dt!=0) { // the clock has changed
	    //storeMeasurement(byteCounter/ (double) (now-last)); // MBps
	    storeMeasurement(1000*byteCounter/ (double) (now-last)); // KBps

	    //System.out.println("BW: "+bw+" bytes per msec");
	    last=now;
	    byteCounter=0;
	}
    }
   
    public void reset() {
	super.reset();
	first=-1;
	byteCounter=0;
	byteSum=0;
    }

    public double calcAverage() {
	// This may be a little bit distorted, because the
	// startTime is set by the constructor.
	// Also, call this as short as possible after the measurement!
	//long now= System.currentTimeMillis();
	double delta =(double) (now-first);
	//System.out.println(delta);
	return 1000*byteSum/ delta; //KBps
    }

}
