package capsule;

import java.io.*;
import stat.*;
import node.*;

public abstract class Meter implements Serializable {
    // Takes measurements on ip packets, stores accumulated result.
    int cntr=0; // The number of measurement results.
    double acc=0; // The accumulated results.
    
    protected MeterAgent agent;

    public void initAgent(MeterAgent a) {
	agent=a;
    }

    public abstract void packetArrival(IPPacket p);

    public double calcAverage() {
	return acc/ (double) cntr;
    }

    public int nrOfMeasurements() {
	return cntr;
    }

    public void reset() {
	cntr=0;
	acc=0;
    }

    protected void storeMeasurement(double m) {
	accumulate(m);  
	agent.notifyMeasurement(m,this); // Maybe the agent needs to know about this
	// particular measurement. Should be done as last step of storeMeasurement.
    }

    protected void accumulate(double m) {
	acc+=m;
	cntr++;
    }

    public String toString() {
	double av=calcAverage();
	StringBuffer buf=new StringBuffer(8*cntr);
	buf.append(super.toString());
	buf.append("\nNumber of  measurements: ");
	buf.append(cntr);
	buf.append('\n');
	buf.append(" accumulate in: ");
	buf.append(acc);
	buf.append(" average: ");
	buf.append(calcAverage());
	return new String(buf);
    }


}
