package capsule;

import clientserver.Result;
import node.*;
import node.services.Service;

import filter.*;
import java.util.*;

public abstract class MeterAgent extends MyAgent {
    protected Meter meter; // is init directly (class cast problem).

    protected int dropped=0;
    protected int treated=0;


    public void handleService (Service s ) {
	System.out.println("Got service result: "+s);
    }

    public void handlePacket(IPPacket p)  {
	meter.packetArrival(p);
	treated++;
    }

    public void emergencyHandle(IPPacket p) {
	dropped++;
    }

    public boolean init(Vector initVector) {
	initMeter();
	return super.init(initVector);
    }


    public abstract void notifyMeasurement(double m, Meter me);
    // The meter notifies
    // the agent that a new measurement was taken. The Meter reference can be used
    // to demultiplex in case of several meters.



    public void stop() {
	StringBuffer buf=new StringBuffer();
	appendEndHeader(buf);
	appendEndResult(buf);
	sendResults(new Result(new String(buf), true));  // A final result message
    }

    public void requestStopService() {
	reply.request(new Service(0, null));
    }

    // methods to compose the final result message.
    protected void appendEndHeader(StringBuffer buf) {
	buf.append("Agent "+name+" is stopped.\n");
	buf.append("Treated packets: "+treated+", dropped packets: "+dropped+"\n");
	buf.append("\nMeasurements: "+meter.nrOfMeasurements());
    }

    protected void appendEndResult(StringBuffer buf) {
	buf.append(" Average accumulation: "+meter.calcAverage());
    }

    protected abstract void initMeter() ;
	// Install the meter for this agent.


    public void sendResults(Result r) {
	// Helper function to send back results.
	reply.request(new Service(1, r));
    }
}
