package capsule;

import clientserver.Result;
import node.*;
import node.services.*;

import filter.*;
import java.util.*;

public abstract class MyAgent implements Agent {
    // Common superclass of all my agents.
    protected String name; // name == classname. Init with the vector.
    protected int ID; 

    protected ServiceChannel reply=null;


    public boolean init(Vector initVector) {
	// Install name and ID in agent.
	try {
	    if (initVector.size() < 2 ) {
		System.err.println("Warning: wrong number of init values! Init failed.");
		return false;
	    }
	    Enumeration e=initVector.elements();
	    name=(String) e.nextElement(); // The agent gets its name/id for
	    ID=((Integer) e.nextElement()).intValue(); // callbacks.
	} catch (Exception e) { // catch ClassCastException 
	    System.err.println("INIT ERR: "+e);
	    e.printStackTrace();
	    return false;
	} 
	return true;
    }

    public void putServiceChannel(ServiceChannel r) {
	reply=r;
    }

    // Helpers to request default node services.

    protected void request(Service s) {
	reply.request(s);
    }

    protected void wakeupCall(int giffies, int n) {
	Vector v=new Vector(2);
	v.addElement(new Integer(giffies)); // giffies
	v.addElement(new Integer(n)); // nr times
	request(new Service(ServiceConsts.WAKE_UP(), v));
    }

    protected void changeChannel(String server, int port, boolean enc, boolean auth) {
	Vector v=new Vector(4);
	v.addElement(server);
	v.addElement(new Integer(port));
	v.addElement(new Boolean(enc));
	v.addElement(new Boolean(auth));
	request( new Service(ServiceConsts.CHANGE_CONNECTION(),v));
    }

    public void requestStopService() {
	request(new Service(ServiceConsts.STOP_ME(), null));
    }

    public void sendResults(Result r) {
	// Helper function to send back results.
	request(new Service(ServiceConsts.SEND(), r));
    }
}
