package capsule;

import node.*;
import utils.*;
import node.services.*;
import clientserver.*;

import java.io.*;
import java.util.*;

public class OneWayDelayAgent extends HashAgent {
    // Can be used to passively determine the one-way delay between nodes.
    // Synchronized clocks are necessary.
    protected static int piggyback=2;

    protected Vector results=new Vector();
    protected int cntr=0;

    protected byte[] myMatch ={127, 54, -117, 66, 
-98, -126, 89, -116, 
70, -106, -47, 47, 
-8, -78, -101, -4};


    public void handlePacket (IPPacket p) {
	if(match(p)) { // Only treat when there's a match.
	    NumericResults nr=new NumericResults(p.timeStamp,p.len()); // To determine the delay,
	    // the app@home must correlate the times of several agents. The p.len is only supplementary.
	    // The ip packet can be used to make sure that the times relate to the same packet.
	    nr.setPacket(p); // For comparison.
	    results.addElement(nr);
	    if(cntr%piggyback==piggyback-1) sendResults(); 
	    else cntr++;
	}
    }

    public  void  initHash() {
	// Init the Hash IVs here.
	from=20; // ip payload.
	to=-1; // Hash the whole payload.
	match= myMatch;
	matchLen=4; // This many bits are compared.
	hashFct=new MD5hash();//new MD5hash(); HeaderMatchHash
    }

    public boolean init(Vector initVector) {
	boolean ret=super.init(initVector);
	changeChannel("speedy.unibe.ch", ProtoConsts.CALLBACK_PORT,false,false);
	return ret;
    }


    public void handleService (Service s ) {}

    public void emergencyHandle(IPPacket p) {}


    public void stop() {
	sendResults(); // Send the rest, if there's still.
    }

    protected void sendResults() {
	if(results.size()>0) {
	    NumericResults nr=new NumericResults(1000*System.currentTimeMillis(),results);
	    nr.result=matched; // The tot number of matched->treated packets (see superclass).
	    sendResults(nr); 
	    cntr=0;
	    results=new Vector();
	}
    }

}
