package capsule;

import stat.*;
import node.*;
import java.util.*;

public abstract class PayloadStatMeter extends Meter {
    // Meters that analyse the payload with the chi-square statistic.

    protected boolean significant; //true=2% fail, false=10% fail
    protected X2 chi;
    protected int offset=52;// do the tests from here on (e.g. ignore ipsec headers).
    // (20 bytes ip header and) 32 bytes ipsec header assumed.
    protected int minNrOfSamples= 1350;// about this nr of samples are used per test.
	//However, the X2 class will not calculate smaller numbers than what is
	//significant.

    protected long byteCntr=0; 

    public  void packetArrival(IPPacket p) {
	byte[] data=p.bytes;


	for(int i=offset; i<data.length ; i++) { // ev add upper bound -20 (dont check esp auth data).
	    byteCntr++;
	    treatByte(data[i]);
	}
    }

    public X2 getX2() {
	// The agent may want to examine the exact V value.
	return chi;
    }


    public void reset() {
	super.reset();
	initChi();
    }

    public String toString() {
	StringBuffer buf=new StringBuffer();
	buf.append(super.toString());
	buf.append('\n');
	//buf.append(chi.toString());
	return new String(buf);
    }

    protected abstract void treatByte(byte b);
    // Prepare statistic byte-wise.

    protected abstract void initChi();


    protected void addNewMeasurement(int s) {
	// Possibly several bytes compose one chi element.
	chi.newMeasurement(s); // Including online recalculation.
	evaluateTest();
    }

    protected void evaluateTest() {
       	// Count number of failed tests.

	if ((byteCntr>=minNrOfSamples) && chi.approximationOk()) { // Now the test is approximative
	    
	    if(chi.succeeds(significant)) {
		
		storeMeasurement(0);
	    } else {
		storeMeasurement(1);
	    }
	    initChi(); // Use a new chi (watch for side-effects).
	    byteCntr=0;
	}
    }

}
