package capsule;

import node.IPPacket;

public class PingSeriesCounter  {
    protected int serieLen;

    public long[] arrival; // should all be 0.

    protected int initSeqNr;

    protected int cntr=0;
    protected int duplicates=0;
    protected int reorderings=0;

    protected int curSeqNr=0; // as offset from initSeqNr

    protected IPPacket curPacket;

    PingSeriesCounter(int len, int sqnr) {
	serieLen=len;
	arrival=new long[serieLen];
	initSeqNr= sqnr;
	initArray();
    }

    public void newArrival(long time, int sqnr) {
	int pos=sqnr-initSeqNr;
	if((pos>=0) && (pos<serieLen)) {
	    if(pos>=curSeqNr) { // A regular arrival.
		putArrival(time,pos);
		curSeqNr=++pos;
	    } else { // Arrival in older slots.
		if(arrival[pos]<0) { // a packet arrived late.
		    reorderings++;
		    putArrival(time,pos);
		} else { // A packet with that seq number was already received.
		    duplicates++;
		}
	    }
	}
    }

    public int duplicates() {return duplicates;}
    public int reorderings() {return reorderings;}

    public int expectedSeqNr() {
	return curSeqNr+initSeqNr;
    }

    public int loss() {
	// evaluate only if time's up:
	return serieLen-cntr;
    }

    public boolean beyond() {
	return curSeqNr>=serieLen;
    }
    protected void putArrival(long time, int pos) {
	arrival[pos]=time;
	cntr++;
    }
    
    protected void initArray() {
	for(int i=0;i<serieLen;i++) {
	    arrival[i]=-1;
	}
    }

}
