package capsule;

import node.*;
import utils.*;
import node.services.*;

import java.io.*;
import java.util.*;

public class TriggerAgent extends HashAgent {
    // When a packet matches myMatch the TriggerAgent relays all method calls to the agent it wraps.
    // So, this agent can be used to have any other agent start its job only when triggered by a specific
    // packet.

    protected byte[] myMatch ={107, 107, 18, -113, 
69, -78, 80, -73, 
72, -58, 76, -106, 
-82, 41, -56, 63};
	//{(byte) 0x45, (byte) 0x00, (byte) 0x04, (byte) 0x5c, (byte) 0xa6, (byte) 0x8c, (byte) 0x00, (byte) 0x00, (byte) 0xf6, (byte) 0x33, (byte) 0x75, (byte) 0x49, (byte) 0x81, (byte) 0xc2, (byte) 0x5a, (byte) 0x14, (byte) 0x82, (byte) 0x5c, (byte) 0x46, (byte) 0x66}; // The match template (the hash that should trigger the agent).
//
    //0, 101, 2,103,4,105,6,107,8,109, 10, 111, 12, 113, 14, 115

    Agent wrapped=new BandwidthAgent(); // Set agent to be triggered here. Don't forget to adapt the .names file.

    boolean activated=false;

    public void handlePacket (IPPacket p) {
	if(!activated) {
	    if(udpPayloadMatch(p))
		activated=true;
	}
	if(activated)
	    wrapped.handlePacket(p);
    }

    public  void  initHash() {
	// Init the Hash IVs here.
	from=28; // udp payload.
	match= myMatch;
	matchLen=128; // This many bits are compared.
	hashFct=new EasyHash();//new MD5hash(); HeaderMatchHash
    }

    public void handleService (Service s ) {
	if(activated)
	    wrapped.handleService(s);
    }

    public void emergencyHandle(IPPacket p) {
	if(activated)
	    wrapped.emergencyHandle(p);
    }
    public boolean init(Vector initVector) {
	if(!super.init(initVector)) return false;
	return wrapped.init(initVector);// Eventually, the init could also be done when the trigger is activated.
    }
    public void stop() {
	wrapped.stop();
    }
    
    public void putServiceChannel(ServiceChannel s) {
	wrapped.putServiceChannel(s);
    }
}
