package capsule;

import node.*;
import clientserver.Result;
import stat.*;
import filter.*;
import java.util.*;

public  class VPNAgent extends MultiMeterAgent {
    // The site-visit demo agent. Measures bw consumption and notifies non-ecryptedness.
    protected double extremeFactor=1.0;// How much the V should't be beyond the 2% percentage points. This should be in the init vector.
    protected static int piggyback=6; // Collect some this many bw measurements before sending.
    protected StringBuffer buff=new StringBuffer(); // Collecting the bw measurement result string.

    protected IPPacket lastIP=null;

    public void handlePacket(IPPacket p) {
	lastIP=p; // store the packet.
	super.handlePacket(p);
    }

    public void notifyMeasurement(double m, Meter mtr) {
	if(mtr instanceof FastByteFrequencyMeter) { //FastRunLengthMeter
	    if (m==1.0) {// If test failed, see if it failed badly.
		X2 chi=((PayloadStatMeter) meter).getX2();
		double V=chi.getV();
		if(chi.isExtremeV(extremeFactor)) { // Stop the agent if this happens
		    Result r=new Result("\nReceived a packet which FAILS the encryption test (factor: "+extremeFactor+")!\n",false);
		    r.setPacket(lastIP);
		    sendResults(r); // deactivated for performance measurements.
		    requestStopService();
		}
	    }
	} else { // BW meter
	    if(mtr.cntr==piggyback) {
		double bw=mtr.calcAverage();
		bw*=8; // In kilo-bits per second (was in bytes per micro-second). 
		buff.append("BW: ");
		buff.append(new Long(Math.round(bw)));
		buff.append(" kbps.");

		Result r=new Result(new String(buff),false);
		r.setOverwrite();
		sendResults(r);
		buff=new StringBuffer();
		mtr.reset();
	    }
	}
    }

  
    protected void initMeter() {
	meters=new Vector(2);
	meters.addElement(new FastByteFrequencyMeter(this,true)); // Order relevant (see appendEndResult)! // FastByteFrequencyMeter
	meters.addElement(new BandwidthMeter(this));
    }


    // Putting together the relevant info for the final result message:
    protected void appendEndHeader(StringBuffer buf) {
	buf.append("Agent "+name+" is stopped.\n");
	buf.append("Treated packets: "+treated+", dropped packets: "+dropped+"\n");
    }

    protected void appendEndResult(StringBuffer buf) {
	super.appendEndResult(buf);
    }
// 	meter=(FastByteFrequencyMeter) meters.firstElement();
// 	buf.append("\nPercentage of failed encryption tests: ");
// 	buf.append(meter.calcAverage());
//     }

}
