package clientserver;

import capsule.*;

import java.io.*;
import java.util.*;
import java.net.*;

public class Client extends PureClient { 
    // The client class for the user-side of SDC.
    // Sends an agent, creates socket and posr
    // Not designed for concurrent use. The gui uses modal windows to synchronize.

    public Client() {} 
    public Client(String srvr) {
	super(srvr);
    }
    public Client(String srvr, int prt) {
	super( srvr,  prt);
    }

    public Client(Socket s) {
	// If the connection is established already (callback).
	socket=s;
	posr=new ProtocolObjectSenderReceiver(socket, "receiverIDUnknown");
	// Note that the other side's info (id, addr) is not set.
    }


     public boolean sendAgent(ExecutionRequest er, String sid, String rid,  byte enc, String passf) {
	 ExecRequestProtocol proto=new ExecRequestProtocol(this);
	 return sendMessage(er,sid,rid, enc,proto,passf); // blocks
     }

    
    protected boolean sendMessage(Message m, String sid, String rid, byte enc, MessageProtocol proto, String passf) {
	// Sends a query. Blocks
	 openConnection(rid);
	 if (socket != null) {
	     proto.sendMessage(m,sid, enc, passf);// Argument is currently ignored.
	     return true;
	 }
	 closeConnection();
	 return false;
    }


     public boolean sendQuery(Query q, String sid, String rid, byte enc, String passf) {
	 QueryProtocol proto=new QueryProtocol(this);
	 return sendMessage(q,sid,rid,enc,proto,passf); // blocks
     }


}
