package clientserver;

public class DecodingResult {
    // Stores the result of the pgp decoding for later analysis.

    protected boolean auth=false;
    protected boolean enc=false;
    protected String id="";
    protected ProtocolObject po=null;


    public DecodingResult(ProtocolObject po) {
	this.po=po;
    }


    public DecodingResult(ProtocolObject po,boolean a, boolean e,String i) {
	this(po);
	auth=a;
	enc=e;
	id=i;
    }

    public boolean isPlain() {
	return (po.encoding==ProtoConsts.PLAIN);
    }

    public boolean isEncrypted() {
	return enc;
    }

    public boolean isSigned() {
	return auth;
    }

    public boolean isAuthentic() {
	// The protocol object is signed by the id provided in the protocol object.
	if(!isSigned())
	    return false;
	if(!signedBy().equals(po.senderID)) 
	    return false;
	return true;
    }

    public String signedBy() {
	return id;
    }

    public ProtocolObject protocolObject() {
	return po;
    }
    
    public String toString() {
	StringBuffer buf=new StringBuffer();

	buf.append("Decoding result:\n");
	if (isPlain()) {
	    buf.append("Plaintext Proto Object: ");
	    buf.append(po.toString());
	} else {
	    buf.append("Encoded object: ");
	    buf.append(po);
	    buf.append("\nSigned by: ");
	    buf.append(signedBy());
	}
	return new String(buf);
    }

}
