package clientserver;

import java.io.*;
import java.util.*;

import filter.*;

public class Message implements Serializable {
    // Represents a protocol message (decrypted/decoded).

    public static Object readObjectFrom(ProtocolObject po) {
	// The protocol object stores the message as ByteArray. Here we decode it.
	// Casting cannot be done here.
	return readObjectFrom(po.message.getInputStream());
    }

    public static Object readObjectFrom(InputStream is) {
	// Instantiate from a byte stream.
	Object r=null;
	ObjectInputStream in;
	try {
	    in=new ObjectInputStream(is);
	    r= in.readObject();
	} catch (Exception e) {
	    System.err.println(e);
	}
	return r;
    }

    public ByteArray exportToByteArray() {
	// For putting into the protocol object and sending.
	ByteArrayOutputStream baOut=new ByteArrayOutputStream();
	try {
	    ObjectOutputStream out=new ObjectOutputStream(baOut);
	    out.writeObject(this);
	} catch (Exception e) {
	    System.err.println("Failed to create ByteArray from ExecutionRequest! Exception: "+e);
	    return new ByteArray(new byte[0]);
	}	
	return new ByteArray(baOut.toByteArray());
    }

}
