package clientserver;

import capsule.*;

import java.io.*;
import java.util.*;
import java.net.*;

public class PureClient { 
    // Encapsulates client specific routines for sending
    // Message (s) (mainly connection handling -open send close).
 
    protected Socket socket=null;
    protected int port=ProtoConsts.PORT;
    protected String servername="localhost";
    protected ProtocolObjectSenderReceiver posr=null;

    public PureClient() {} 
    public PureClient(String srvr) {
	servername=srvr;
    }
    public PureClient(String srvr, int prt) {
	this(srvr);
	port=prt;
    }

    ProtocolObjectSenderReceiver getProtocolObjectSenderReceiver() {
	// Used by MessageProtocol
	return posr;
    }
 
    protected void openConnection(String receiverID) {
	// also generates the protocol object sender/receiver.
	try {
	    socket=new Socket(servername, port);
	} catch (Exception e) {System.err.println(e); socket=null;}
	posr=new ProtocolObjectSenderReceiver(socket, receiverID);
    }

    


//     protected  void sendStream(InputStream source) {
// 	// Not used any more.
// 	OutputStream o;
// 	int b;
// 	try {
// 	    socket=new Socket(servername, port);
// 	    o=socket.getOutputStream();
// 	    while((b=source.read())>-1) {
// 		//System.out.print(b);
// 		o.write(b);		System.out.print(b);

// 	    }
// 	    o.flush();
// 	    //closeSocket();
// 	} catch (Exception e) {System.err.println(e);}
//     }

    void closeConnection() { // This can also be called by the protocol handler
	if(socket !=null)
	    try {
		socket.close();
	    } catch (IOException e) {
		System.err.println("Client: "+e);
	    }
    }

}
