package clientserver;

import java.util.*;
import homeApplication.QueryProtoDisplay;

public class QueryProtocol extends MessageProtocol {
    // Steers the client part of the interaction protocol to query the policy of a node.


    public QueryProtocol(Client c) {
	init(c);
	display=new QueryProtoDisplay(this); 
    }
 
    public synchronized void sendMessage(Message m, String sid, byte enc, String passf) {
	if(!(m instanceof Query)) {
	    System.err.println("Error: expecting a Query.");return;
	} 
	initPGPExpectations(passf,enc); // The answer should use the same passphrase and
	// encoding.
	sendQuery((Query) m, sid, enc);
    }
   
    public byte messageType() {return ProtoConsts.QUERY;}


    protected synchronized void sendQuery(Query q, String id, byte enc) {
	// The protocol flow. Send a query, then receive an answer.
	ProtocolObject po= createRequest(q,id,enc);// sets posr as well.
	display.show(); // activate the gui window.

	if(posr.send(po,passPhrase)) { 
	    Message res=receiveResult();
	    display.handle(res);
	} else
	    display.handle(new QueryResult("Could't send/encode the message! \nWrong IDs or passphrase?"));
    }


    protected Message receiveResult() {
	Message res=new QueryResult("Could not receive Result!");
	DecodingResult dr=posr.receive(passPhrase);
	if(dr != null ) {
	    ProtocolObject po=dr.protocolObject();
	    checkAuthenticity(dr);
	    if (po != null) {
		if (po.messageType==ProtoConsts.QUERY_RES) {
		    res= (Message) Message.readObjectFrom(po);
		}
	    }
	}
	return res;
    }

}
