package clientserver;

import node.IPPacket;

public class Result extends Message {
    // Carries replies from the agent.
    // Currently features only a string representation, 
    // but this can of course be extended.

    protected String reply;
    protected boolean last=true; // indicates if other results will follow.
    protected boolean overwrite=false; // indicate to the result displayer to overwrite this result with the next

    protected IPPacket ip=null; // Result can carry an interesting ip packet.

    public Result(String s) {
	// For final result
	reply=s;
    }

    public Result(String s, boolean l) {
	reply=s;
	last=l;
    }

    public void setPacket(IPPacket i) {
	ip=i;
    }

    public void setOverwrite() {
	overwrite=true;
    }

    public IPPacket ip() {
	return ip;
    }

    public boolean isLast() {
	return last;
    }

    public boolean overwrite() {
	return overwrite;
    }



    public String toString() {
	return reply;
    }
}
