package clientserver;


import java.io.*;
import java.net.*;

import homeApplication.CallBackDisplay;

public class Server { 
    // The server that accepts requests/queries from the user.
    protected int serverPort;
    protected ServerSocket ss;
    protected Socket socket;
    protected CallBackHandler handler;
    protected boolean cont=true;
    protected CallBackDisplay display;

    public Server(int port, CallBackHandler handler, CallBackDisplay d) {
	display=d;
	serverPort=port;
	this.handler=handler;
    }

    public void serverLoop() {
	try {
	    ss=new ServerSocket(serverPort);
	    System.out.println("Server started");
	    while(cont) {
		socket=ss.accept();
		handler.initWith(socket, display);
		Thread handling=new Thread(handler);
		handling.start();	    }
	} catch (Exception e) {System.err.println(e);}
    }

    public void stop() {
	cont=false;
	try{ss.close();} catch (Exception e) {System.err.println(e);}
    }


    public static void  main(String[] args) {
	// testing (only on user side.. rest is the same)
	Server s=new Server(ProtoConsts.CALLBACK_PORT, new CallBackHandler(),null);
	s.serverLoop();
    }
}
