package filter;

import java.io.*;

public class Length implements Serializable {
    // Represents a count or a length. Thus it is positive.
    // Negative values represent any count or length.
    // This class is used in Filter.

    protected int rep=0;

    public Length(int i) {
	rep=i;
    }

    public int getNr() {
	return rep;
    }

    public boolean equals(Length l) {
	int other=l.rep;
	if (rep==other) return true;
	if (meansAny(other) && meansAny(rep))
	    return true;
	return false;
    }


    public void and(Length l) {
	// take the minimum. 
	int other=l.rep;
	if(meansAny(other)) return;
	if (meansAny(rep)) rep=other;
	else if (other<rep) rep=other;
    }

    public Length niAnd(Length l) {
	// non intrusive and.
	int other=l.rep;
	if(meansAny(other)) return new Length(rep);
	if (meansAny(rep)) return new Length(other);
	else if (other<rep)  return new Length(other);
	return new Length(rep);
    }

    public boolean meansAny() {
	return meansAny(rep);
    }

    public String toString() {
	if (meansAny()) return "Any";
	return new Integer(rep).toString();
    }

    protected boolean meansAny(int i) {
	// A negative value means any positive number.
	return (i<0);
    }

    protected void appendTo(StringBuffer b) {
	if  (meansAny(rep))
	b.append("any");
	else 
	b.append(rep);
    }

}
