package filter;

import java.io.*;

import node.IPPacket; // for the IPPacket def.
import utils.*;

public class PortMatcher implements Serializable {
    // Helper class that determines if a packet matches the port spec of a filter.
    // The problem is that the port is dependent of the protocol of the packet.

    protected IPPacket ip;

    public void setPacket(IPPacket ip) {
	this.ip=ip;
    }

    public boolean hasPort() {
	short proto=ip.proto();
	if(proto == 6) return true;
	if(proto == 17) return true;
	return false; // not tcp or udp
    }

    public boolean matches(ListOfRanges ports) {
	if (ports instanceof All) return true;
	if (hasPort()) {
	    if(portVisible()) {
		int port1=ip.toNumber(20,2);
		int port2=ip.toNumber(22,2);
		//System.out.println("P1: "+port1+" P2: "+port2+" Filter: "+ports);
		return (ports.match(port1) || ports.match(port2)); // ok if it matches either src or dest port.
	    } else return true; // in dubio...
	}
	return true; // if port means nothing, we match.
    }

    public boolean portVisible() {
	int idLow=ip.toNumber(7,1);
	if(idLow != 0) {
	    System.out.print("*PortMatcher:FragWarning*");
	    return false; // For fragments, we don't know so don't filter it
	}
	return true;
    }
    
}
