package filter;

import java.io.*;

import utils.*;

public class VRFilterStringGenerator implements Serializable {
    //gimme -number 100 -every 4 -src 10.10.10.10/8 -dst 11.12.13.14/24 -proto 6 -datalen 0 -tos 0 -version 4

    // Currently only: gimme -number 100 -src 10.10.10.10/8 -dst 11.12.13.14/24 -proto 6 -datalen 0

    protected StringBuffer buf;
    
    public String filterString(Filter f) {
	// use this method to get the request line to be sent to a vr.
	buf=new StringBuffer();
	buf.append("gimme");
	appendLength(" -number ", f.packets());

	// omit '-every'
	addIPaddressFlag(" -src ", f.source());
	addIPaddressFlag(" -dst ", f.destination());
	
	appendProtocol(f.protocol());

	appendLength(" -datalen ", f.getIPLen());
	buf.append('\n');
	return new String(buf);

    }

    protected void addIPaddressFlag(String minus, ListOfRanges ranges) {
	// The first range is translated to the format: 10.10.10.10/8
	if (ranges instanceof All) return; // Matches everything, thus omit switch.
	Range range=(Range) ranges.first(); // Unfortunately, we can only treat the first range.
	buf.append(minus);
	buf.append(range.toNetNotation());
    }
    
    protected void appendProtocol(ListOfRanges ranges) {
	// unfort. as vr filter options only one single protocol is supported.
	if (ranges instanceof All) return; // Matches everything, thus omit switch.
	Range range=(Range) ranges.first();
	buf.append(" -proto ");
       	buf.append(range.low());
    }

    protected void appendLength(String minus, Length l) {
	if (l.meansAny()) return;
	buf.append(minus);
	buf.append(l.getNr());
    }

    public static void main(String[] args) {
	Range r=new Range(1000000000,1000000007);
	ListOfRanges l=new ListOfRanges(r);
	Filter f= new Filter(l, l , l, l, 48, -1); // new Filter(1000000000, 1000000, 23, 80 , 100, 40) ;
	VRFilterStringGenerator gen= new VRFilterStringGenerator();
	System.out.println(gen.filterString(f));
	    //new Filter(ListOfRanges s, ListOfRanges d,ListOfRanges sp, ListOfRanges p, int l, int pl) 
    }
}
