package homeApplication;

/* Written by Manuel Gnter. All rights reserved, no warranties */

import java.awt.*;
import java.io.*;


public class BinaryPainter  extends DataxelPainter {
    // Displays one byte as eight dataxels (colored, filled boxes).
    // Bits are displayed lowest-order first (maybe that should change).
    // Bit one is colored black, zero white.

    public BinaryPainter(DataxelPainter p) {
	super(p);
    }

    public BinaryPainter(DataxelCanvas c, InputStream i) {
	super(c,i);
    }

    public int BitsPerDataxel() {
	// to calculate the size needed for the canvas.
	return 1;
    }

    protected void drawByte(int b, Graphics g) {
	for (int i=0; i<8; i++) {
	    if (b%2>0) {
		red=green=blue=0;
	    } else {
		red=green=blue=255;
	    }	
	    canvas.drawNext(calcColorFromComponents(), g);
	    b= b>>1;
	}
    }

}
