package homeApplication;

/* Written by Manuel Gnter. All rights reserved, no warranties */

import java.awt.*;
import java.io.*;


public class DataxelPainter {
    // Maps a byte to one or several dataxels (colored, filled boxes).

    DataxelCanvas canvas;
    int red,blue,green, alpha=255;

    InputStream in;

    byte[] bytes;

    public DataxelPainter(DataxelCanvas c, InputStream i) {
	canvas=c;
	in =i;
	readAllBytes();
    }

    public DataxelPainter(DataxelPainter p) {
	// This constructor is used to change to new painters on the fly.
	canvas=p.canvas;
	in =p.in;
    }

    public  void drawAll(Graphics g) {
	try{
	    while (in.available()>0) {
		drawByte(in.read(),g);
	    }
	    in.reset();
	} catch (IOException e) {System.err.println(e);}
    }

    public int BitsPerDataxel() {
	// to calculate the size needed for the canvas.
	return 8;
    }

    protected void drawByte(int b, Graphics g) {}
    // Override this dummy method. Use callback to 
    // canvas.drawNext(color, g);
    

    protected void readAllBytes() {
	ByteArrayOutputStream out= new ByteArrayOutputStream();
	try{
	    while (in.available()>0) {
		out.write(in.read());
	    }
	} catch (IOException e) {System.err.println(e);}
	bytes= out.toByteArray();
	in= new ByteArrayInputStream(bytes);
    }

    protected int calcColorFromComponents() {
	return (alpha << 24) | (red << 16) | (green << 8) | blue;
    }
}
