package homeApplication;

import java.awt.*;
import java.awt.event.*;

import filter.*;
import clientserver.*;
import utils.AddressCalculator;
import topology.NodeRecord;

public class Dialogs extends Dialog implements ActionListener {
    // Superclass of the dialogs that collect the data to form a message
    // from the client to the server.

    protected Frame father; // Every dialog has a parent.
    protected Button send;
    protected Button cancel;
    protected Panel buttons;

    public Dialogs(Frame father, String titel, boolean modal) {
	super(father, titel, modal); // The dialog is  modal.
	this.father=father;
    }


    public void initButtons() {
	buttons=new Panel();
	send=new Button("Send");
	cancel=new Button("Cancel");

	send.addActionListener(this);
	cancel.addActionListener(this);

	buttons.add(send,BorderLayout.WEST); buttons.add(cancel,BorderLayout.EAST);

    }

    public void actionPerformed(ActionEvent e) {
	String command=e.getActionCommand(); 
	if(command.equals("Cancel")) {
	   stopDialog();
	} else if (command.equals("Send")){
	    gatherDataNsend();
	}
    }

    protected void gatherDataNsend() {
	System.err.println("Do not instantiate 'Dialogs' but one of its subclasses!");
    }


    protected String getPassphrase(String senderID, byte encoding) {
	String ret=null;
	if((encoding==ProtoConsts.FULL_PGP_v263i) || (encoding==ProtoConsts.SIGN_PGP_v263i)) {
	    SingleEntryDialog ask=new SingleEntryDialog(father, "Enter passphrase for: "+senderID, false , true);
	    ask.setVisible(true);
	    ret=ask.getInput();
	}
	return ret;
    }

    protected void stopDialog() {
	setVisible(false);
	//dispose();
    }

    protected Client createClientFromFrom(MessageForm mform) {
	// Extract the necessary data to create a client from the given message form.
	NodeRecord targetNode=mform.parseReceiverID(); // Get the receiver node.
	return new Client(AddressCalculator.toString(targetNode.ip).toString(), targetNode.port);
    }

}
