package homeApplication;

import java.awt.*;
import java.awt.event.*;

import node.IPPacket;
import utils.PacketCharacterPrinter;
import clientserver.*;

public class ExecProtoDisplay extends ProtoDisplay implements ItemListener {
    // Created by clientserver.ExecutionProtocol. This frame displays
    // the results sent back by the agent.

    
    protected Button stop;
    protected PacketDisplayer packetDisplayer=new PacketTextDisplayer();
    protected Panel displayHolder=new Panel();

    protected static String statustxt="Status:";

    protected static String hexRep="Hex Text"; // The packet representation options.
    protected static String charRep="Char Text";
    protected static String graphRep="Graphical";


    protected TextField status=new TextField(statustxt,60);
    protected TextArea results=new TextArea( "Results of the agent",20,60);

    protected IPPacket ip=null; // The last received ip packet to display.

    public ExecProtoDisplay(ExecRequestProtocol p) {
	//setLayout(new GridLayout(4,1,5,5));
	setLayout(new FlowLayout());

	init(p);
	stop=new Button("Stop");
	stop.setSize(280,100);// Doesn't work
	status.setEditable(false);
	results.setEditable(false);
	displayHolder.add(packetDisplayer); // The pD is in a holder, in order
	// to be dynamically replacable.

	stop.addActionListener(this);
	add(status);	
	add(results); 
	add(createRepChoice());
	add(displayHolder);	
	add(stop);
	setSize(550,770);	
    }


    public void handle(Message m) {
	// The protocol sends a new result.
	if (!(m instanceof Result)) {
	    System.err.println("Error: received result "+m+" is not of class Result.");
	    return;
	}
	Result r= (Result) m;
	if(r.ip() != null) { 
	    ip=r.ip();
	    packetDisplayer.displayPacket(ip);
	}
	if(r.overwrite()) {
	    results.replaceRange(r.toString(),0,30);
	} else {
	    results.append("\n");
	    results.append(r.toString());
	}
    }

    public void actionPerformed(ActionEvent e) {
	String command=e.getActionCommand(); 
	if(command.equals("Stop")) {
	    stop();
	}
    }
    public void itemStateChanged(ItemEvent e) {
	String command= (String) e.getItem();
	PacketDisplayer p;
	if(command.equals(hexRep)) {
	    p=new PacketTextDisplayer();
	} else if(command.equals(charRep)) {
	    p=new PacketTextDisplayer(new PacketCharacterPrinter());
	} else  if(command.equals(graphRep)) {
	    p=new GraphicalPacketDisplayer();
	} else return;
	changePacketDisplayer(p);
    }

    protected void changePacketDisplayer(PacketDisplayer displayer) {
	displayHolder.remove(packetDisplayer);
	packetDisplayer=displayer;
	displayHolder.add(displayer);
	if(ip!=null) packetDisplayer.displayPacket(ip);
	validate();	    // Important to have the new packet displayed.
    }


    protected Panel createRepChoice() {
	// The panel that let's the user choose a packet displayer.
	Panel p=new Panel();
	Label l=new Label("Packet representation:");
	Choice c= new Choice();
	c.addItem(hexRep);
	c.addItem(charRep);
	c.addItem(graphRep);
	c.addItemListener(this);
	p.add(l,BorderLayout.WEST);
	p.add(c,BorderLayout.EAST);
	return p;
    }


    //    protected void interestingPacket(IPPacket ip) {
    //	// called by the exec request proto.
    //	packetDisplayer.displayPacket(ip);
    //}

    public void setStatus(String s) {
	status.setText(s);
    }

}
