package homeApplication;

import java.awt.*;
import java.awt.event.*;

import node.IPPacket;


public  class GraphicalPacketDisplayer extends PacketDisplayer implements ItemListener{

    protected DataxelCanvas canvas;
    protected String binary="Binary/BW";
    protected String grey="Grey";
    protected String rgb1="8bitRGB";
    protected String hsb1="8bitHSB";

    protected Dimension scrollPsize = new Dimension(500,300);
    protected ScrollPane scrollPane=null;

    public GraphicalPacketDisplayer() {

	setLayout(new BorderLayout());


	add( generateChoice(),BorderLayout.NORTH);

	scrollPane = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);// SCROLLBARS_AS_NEEDED SCROLLBARS_ALWAYS
	scrollPane.setSize(scrollPsize);
	add( scrollPane, BorderLayout.SOUTH);
	setSize(550,400);
	       
    }


    public void displayPacket(IPPacket ip) {
	// The old scroll pane is replaced by a new scroll
	// pane (with the packet displayed in a dataxel canvas). An
	// alternative would be to extend dataxel canvas to display several packets at
	// once.
	remove(scrollPane);
	scrollPane = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);// SCROLLBARS_AS_NEEDED SCROLLBARS_ALWAYS
	canvas=new DataxelCanvas(ip);
	scrollPane.add(canvas);
	scrollPane.setSize(scrollPsize);
	add( scrollPane, BorderLayout.SOUTH);
	validate();	    // Important to have the new packet displayed.
    }


    public void itemStateChanged(ItemEvent e) {
	String command= (String) e.getItem();
	DataxelPainter p;
	if(command.equals(binary)) {
	    p=new BinaryPainter(canvas.getPainter());
	} else 
	    if(command.equals(grey)) {
		p=new GrayPainter(canvas.getPainter());
	    } else 
		if(command.equals(rgb1)) {
		    p=new  EightBitColorPainter(canvas.getPainter());
		} else 	
		    if(command.equals(hsb1)) {
			p=new  EightBitHSBPainter(canvas.getPainter());
		    } else return;
	canvas.setPainter(p);
    }



    protected Choice generateChoice() {
	Choice c= new Choice();
	c.addItem(grey);
	c.addItem(rgb1);
	c.addItem(hsb1);
	c.addItem(binary);
	c.addItemListener(this);
	return c;
    }

    public static void main(String[] args) {
	// test
	Frame f=new Frame();

	f.add(new GraphicalPacketDisplayer());

	f.setSize(700,700);

	f.pack();
	f.show();

    }

}
