package homeApplication;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.util.*;

import topology.*;
import clientserver.*;
import utils.*;


public abstract class MessageForm extends Panel implements ActionListener {
    // The user can fill in form describing where and how to
    // send a  message. It is not complete, but contains code
    // that would otherwise be duplicated.

    protected static String pgp="PGP"; // To identify the  list entries.
    protected static String sign="SIGN ONLY"; 

    protected TextField sid, rid;
    protected List enc, forw;
    protected Label si,ri,e,f;

    public void init() {
	createFields();
	initFields(); // The default values.
    }

    protected void createFields() {
	// Do set a layout before calling this, eg setLayout(new GridLayout(5,2,5,5));
	sid=new TextField(20);
	rid=new TextField(20);
	enc=new List(1);
	forw=new List(1);
	si=new Label("Sender ID"); ri=new Label("Receiver ID"); e=new Label("Encoding"); f=new Label("Forwarding");
	sid.addActionListener(this);rid.addActionListener(this);enc.addActionListener(this);forw.addActionListener(this);

	add(si);add(sid);
	add(ri);add(rid);
	add(e);add(enc);
	add(f);add(forw);
    }

    public String senderID() {
	return sid.getText();
    }
    public String receiverID() {
	return rid.getText();
    }
    public ForwardingDescriptor forwarding() { // Is treated as if part of 'Message'.
	return parseForwarding(); // However, currently it's part of ExecutionRequest.
    }

    public byte encoding() {
	return parseEncoding();
    }

    public boolean userDataReady() {
    // Checks if the user input is complete.
	if (enc.getSelectedItem()==null)
	    return false;
	if (parseForwarding()==null)
	    return false;
	if (sid.getText().equals(""))
	    return false;
	if (!validateReceiverID() )
	    return false;
	return true;
    }
    protected void initFields() {
	// The default values
	sid.setText("demouser"); //demouser <mguenter@iam.unibe.ch>
	rid.setText("<admin@iam.unibe.ch>");
	enc.add("PLAIN");// PLAIN, SIGN ONLY, PGP
	enc.add(pgp);
	enc.add(sign);
	enc.select(0);
	forw.add("Point2Point");
	forw.select(0);
    }


//     protected boolean validateNodeEntry() {
// 	String entered=node.getText();
// 	if(entered.trim().equals("")) return false;
// 	try {
// 	    InetAddress a=InetAddress.getByName(entered);
// 	    return true;
// 	} catch (UnknownHostException e) {
// 	    node.setText("Unkown host!");
// 	}
// 	return false;
//     }


    protected byte parseEncoding() {
	// Determines the kind of encoding for the protocol object.
	// Since there is only one option, we do ignore the user choice.
	//enc.getSelectedItem();
	String entry=enc.getSelectedItem();
	if(entry.equals(pgp)) return ProtoConsts.FULL_PGP_v263i;
	if(entry.equals(sign)) return ProtoConsts.SIGN_PGP_v263i;
	else return ProtoConsts.PLAIN;
    }

    protected ForwardingDescriptor parseForwarding() {
	// Determines what the node should do with the protocol object.
	// Only execution requests can be further forwarded.
	return new ForwardingDescriptor(); // A 'do nothing' descriptor.
    }

    protected NodeRecord parseReceiverID() {
	// The id is used to determine ip and port of the node.
	String rec=rid.getText();
	NodeRecord ret=SDC.nodeLookup.recordOf(rec); // Lookup if the node is known.
	if (ret != null)
	    if (ret.isUser) return null; // Only consider real nodes.
	return ret;
    }

    protected boolean validateReceiverID() {
	// Ok if the lookup is successful. Could also include doing a dns lookup
	boolean ret= (parseReceiverID() != null);
	if (!ret) rid.setText("Unknown node!");
	return ret;
    }

    protected void selectSignOnly() {
	// Forwarding of agents needs the encoding option 'select only'. This
	// method sets the selection. Warning: make sure the index fits
	// with the order introduced in 'initFields()'.

	// deactivate mandatory signing here
	int indexSign=2; // make sure..
	enc.select(indexSign);
	enc.makeVisible(indexSign);
    }
}
