package homeApplication;

import java.awt.*;
import java.awt.event.*;

import clientserver.*;
import utils.*;


public class QueryForm extends MessageForm implements ActionListener, ItemListener {
    // The user can fill in a form saying who sends what query to where. 


    protected Query query=null;
    protected int type=0;

    protected final static String free="Free ressources";
    protected final static String agentsState="Agents' state";
    protected final static String policy="Node policy";
    protected final static String services="Node services";
    protected final static String neighbors="Neighbor nodes";
    protected final static String routing="Routing";

    public QueryForm() {
	setLayout(new GridLayout(5,2,5,5));
	init();
    }

    public void createFields() {
	super.createFields();
	Label qt= new Label("Query type:");
	add(qt);add(createTypeChoice());
    }


    // Call 'userDataReady()' before using these getters
    public Query getQuery() {
	Query ret=new Query(type);
	return ret;
    }

    public void actionPerformed(ActionEvent e) {
	Object t= e.getSource(); 
	if(t== rid) {
	    validateReceiverID();
	}// not all entries are validated
    }


    public void itemStateChanged(ItemEvent e) {
	// Add new types here.
	String command= (String) e.getItem();
	if(command.equals(free)) {
	    type=Query.FREE;
	} else  if(command.equals(agentsState)) {
	    type=Query.AGENTS_STATE;
	} else  if(command.equals(policy)) {
	    type=Query.POLICY;
	} else  if(command.equals(services)) {
	    type=Query.NODE_SERVICES;
	} else  if(command.equals(neighbors)) {
	    type=Query.NEIGHBORS;
	} else  if(command.equals(routing)) {
	    type=Query.ROUTING;
	} else return;
    }

    protected Choice createTypeChoice() {
	// The panel that let's the user choose a query type.
	Choice c= new Choice();
	c.addItem(free);
	c.addItem(agentsState);
	c.addItem(policy);
	c.addItem(services);
	c.addItem(neighbors);
	c.addItem(routing);
	c.addItemListener(this);
	return c;
    }

}
