package homeApplication;

import topology.*;

import java.awt.*;
import java.awt.event.*;


public class SDC extends Frame implements ActionListener {
    public static NeighborLookupTable neighborLookup; // Has access to a central conf file.
    public static NodeLookupTable nodeLookup; // Has access to a central conf file.

    protected Button quit, query, execReq, help;
    protected Panel panel=new Panel();

    public SDC() {
	quit=new Button("Quit");
	query=new Button("Query");
	execReq=new Button("Send");
	help=new Button("Help");
	panel.add(quit); panel.add(query); panel.add(execReq); panel.add(help);
	quit.addActionListener(this); query.addActionListener(this); 
	execReq.addActionListener(this); help.addActionListener(this);
	add(panel, BorderLayout.SOUTH);	
    }

    public void actionPerformed(ActionEvent e) {
	String command=e.getActionCommand(); 
	if(command.equals("Send")) {
	    startSendingDialog();
	} else if(command.equals("Query")) {
	    startQueryDialog();
	} else if(command.equals("Quit")) {
	    quit();
	} else if(command.equals("Help")) {
	    help();
	}
	
    }

    protected void startSendingDialog() {
	Dialog dialog=new SendingDialog(this, "Form for sending an agent.");
	dialog.setVisible(true);
    }

    protected void startQueryDialog() {
	// To be implemented
	Dialog dialog=new QueryDialog(this, "Form for querying a node.");
	dialog.setVisible(true);
    }

    protected void quit() {
	dispose();
	System.exit(0);
    }

    protected void help() {
	// To be implemented
    }

    public static void main(String[] args) {
	// init static topology lookup. Make sure these are the files used by the nodes, too:
	String topoPath="/home/mguenter/rvs/Agents/topology/";
	neighborLookup=new NeighborLookupTable(topoPath+"neighbor.global.config"); 
	nodeLookup=new NodeLookupTable(topoPath+"nodes.global.config"); 

	Frame f=new SDC();
	f.setTitle("SDC");
	//f.setSize(200,200);
	f.pack();
	f.show();

	
    }
}
