package homeApplication;

import java.awt.*;
import java.awt.event.*;

import filter.*;
import clientserver.*;

import netgui.ValueDisplayer;

public class SendingDialog extends Dialogs implements ActionListener, ItemListener {
    // Collects the user data for sending an execution request.

    protected FilterForm fform=new FilterForm();
    protected ExecutionMessageForm mform;

    protected static String statustxt="Status:            ";
    protected TextField status=new TextField(statustxt);
    protected Checkbox  cb; // Should there be a callback server?
    protected ValueDisplayer vd=null; // As a template for the CallBackDisplayer.

    public SendingDialog(Frame father, String titel) {
	super(father, titel, true); // The dialog is  modal.
	mform=new ExecutionMessageForm(father);
	setLayout(new FlowLayout());
	Label filter=new Label("          The filter:");
	Label info=new Label("Infos about agent and mission:");
	status.setEditable(false);
	cb=new Checkbox("Start callback server?");
	cb.addItemListener(this);

	initButtons(); // super-init for the cancel and send buttons.

	add(info);
	add(mform);
	add(cb);
	add(filter);
	add(fform);
	add(status);
	add(buttons);
	//pack(); // makes sense with another layout
	setSize(400,565);
    }


     protected void gatherDataNsend() {
	 // If all data is there and valid, send it.
	 if(!mform.userDataReady()) {
	     status.setText("Not all message fields are valid!");
	     return;
	 }
	 ExecutionRequest er=mform.getExecutionRequest();
	 if(!fform.userDataReady()) {
	     status.setText("Not all filter fields are valid!");
	     return;
	 }

	 startCallbackIfRequested(er);

	 byte enc=mform.encoding(); 
	 String sid=mform.senderID();
	 String pass=getPassphrase(sid,enc); // starts a dialog if necessary.
	 er.forwarding=mform.forwarding();


	 Client client= createClientFromFrom(mform);

	 er.filter=fform.getFilter();

	 status.setText("Sending agent...");
	 ExecClientThread resultDisplayer=
	     new ExecClientThread(father,client, er, sid, mform.receiverID(), enc,pass);
	 resultDisplayer.start(); 
	 // wait a little..
	 stopDialog();
     }

    protected void startCallbackIfRequested(ExecutionRequest er) {
	if(cb.getState()) { // Start independent callback-receiving window.
	    CallBackDisplay cbd=new CallBackDisplay(er, vd);
	    Thread t=new Thread(cbd);
	    t.start(); 
	    cbd.setSize(660,500);
	    //cbd.pack();
	    cbd.show();
	}
    }

    public  void itemStateChanged(ItemEvent e) {
	if(cb.getState()) {
	    ValueDisplayInitDialog dialog=new ValueDisplayInitDialog(father);
	    dialog.pack();
	    dialog.setVisible(true);
	    vd=dialog.valDisplayerTemplate();
	    // Ask for display unit
	}
    }

}
