package homeApplication;

import java.awt.*;
import java.awt.event.*;



public class SingleEntryDialog extends Dialog implements ActionListener {
    // A generic dialog that gets a single user input.
    protected TextField entry;
    protected boolean valid=false; // to externally parse the value.

    public SingleEntryDialog(Frame father, String question, boolean visible, boolean modal) {
	super(father, "Question", modal); // The dialog is  modal.
	Button ok=new Button("OK");
	Label text=new Label(question);
	entry=new TextField();
	if (!visible)
	    entry.setEchoChar('#'); // don't show the passphrase.
	ok.addActionListener(this);
	entry.addActionListener(this);
	add(text,BorderLayout.NORTH);
	add(entry,BorderLayout.CENTER);
	add(ok,BorderLayout.SOUTH);
	pack();
    }

    void setValid() {valid=true;}
    void setInvalid(){valid=false;}
    public boolean isValid() {return valid;}

    void setText(String txt) {
	entry.setText(txt);
    }

    String getInput() {
	return entry.getText();
    }

    public void actionPerformed(ActionEvent e) {
	setVisible(false);
	//	dispose();
    }

}
