package homeApplication;

import java.awt.*;
import java.awt.event.*;
import netgui.ValueDisplayer;


public class ValueDisplayInitDialog extends Dialog implements ActionListener {
    // Asks the user for input to init the netgui.ValueDisplayer of the CallBackDisplayer.
    protected Label l0,l1,l2,l3;
    protected TextField t1,t2,t3;
    protected Button ok=new Button("ok");

    protected ValueDisplayer vd;

    public ValueDisplayInitDialog(Frame father) {
	super(father, "Provide display scale units:" , true); // The dialog is  modal.
	initPanel();
	l0=new Label("Provide display scale units:");
	add(l0,  BorderLayout.NORTH);
	add(ok,  BorderLayout.SOUTH);
	ok.addActionListener(this);
    }

    public ValueDisplayer valDisplayerTemplate() {
	// Call after the dialog was filled out.
	return vd;
    }

    protected void initPanel() {
	l1=new Label("Min:");
	l2=new Label("Max:");
	l3=new Label("Unit:");
	t1=new TextField(6);
	t2=new TextField(6);
	t3=new TextField(6);
	Panel p=new Panel();
	p.setLayout(new GridLayout(3,2,5,5));
	p.add(l1); p.add(t1);
	p.add(l2); p.add(t2);
	p.add(l3); p.add(t3);
	add(p, BorderLayout.CENTER);
	
	// init vals:
	t1.setText("0");
	t2.setText("10000");
	t3.setText("KBps");

    }


    public void actionPerformed(ActionEvent e) {
	String command=e.getActionCommand(); 
	if(command.equals("ok")) {
	    parseValueDisplayUnits();
	    stopDialog();
	}
    }

    protected void parseValueDisplayUnits() {
	double min=parseDoubleFrom(t1);
	double max=parseDoubleFrom(t2);
	String unit=t3.getText();
	vd=new ValueDisplayer(unit,min,max); //sets the template that will be used.
	

    }

    protected double parseDoubleFrom(TextField tf) {
	String d=tf.getText();
	Double ret=new Double(0);
	try{ret=Double.valueOf(d);} catch(NumberFormatException e) {}
	return ret.doubleValue();
    }

    protected void stopDialog() {
	setVisible(false);
	//dispose();
    }

}
