package netgui;

import java.awt.*;
import java.util.*;

public class Domain  extends RellocNetComponent{

    protected Vector routers=new Vector();
    protected int r=50;


    public Domain(String id, int r) {
	if(r>0) 
	    this.r=r;
	netName=id; // no special net name.
	ownerID=id;
    }

    public Domain(int nr, int r) {
	setInitPos(nr);
	if(r>0) 
	    this.r=r;
    }

    public boolean equals(Domain o) {
	if(ownerID.equals(o.ownerID))
	    return true;
	return false ;
    }
    
    public void paintOn(Graphics g) {
	if (selected) 
	    g.setColor(selectedColor);
	else 
	    g.setColor(foreground);
	int d=2*r;
	g.fillOval(x-r,y-r,d,d);
	paintText(g);
	paintRouters(g);
    }

    protected void paintText(Graphics g) {
	setFontSize(10, g);
	g.setColor(foreground2);
	int r2=r/2;
	g.drawString(ownerID,x-r2,y+r2); // Draw centered in the lower half 
    }

    public int radius() {return r;}
    public int routers() {return routers.size();}

    NetComponent touching(int x, int y) {
	NetComponent router=checkRouterTouch(x,y); 
	if(router!=null) return router;
	int dx=(x-this.x);
	dx=dx*dx;
	int dy=(y-this.y);
	dy=dy*dy;
	if (dx+dy <= r*r) return this;
	return null;
    }

    void addRouter(Router r) {
	routers.addElement(r);
    }

    protected Router search(Router template) {
	Router r=null;
	Object o;
	for(Enumeration e=routers.elements(); e.hasMoreElements(); ) {
	    o=e.nextElement();
	    if (o instanceof Router) {
		r=(Router) o;
		if (r.equals(template)) break;
		else r=null;
	    }
	}
	return r;
    }


    protected void paintRouters(Graphics g) {
	Router r;
	for(Enumeration e=routers.elements(); e.hasMoreElements(); ) {
	    r=(Router) e.nextElement();
	    r.paintOn(g);
	}
    }

    protected NetComponent checkRouterTouch(int x, int y) {
	Router r;
	for(Enumeration e=routers.elements(); e.hasMoreElements(); ) {
	    r=(Router) e.nextElement();
	    if(r.touches(x,y)) return r;
	}
	return null;
    }

    void move(int x, int y) {
	int dx=x-this.x;
	int dy=y-this.y;
	
	Router r;
	for(Enumeration e=routers.elements(); e.hasMoreElements(); ) {
	    r=(Router) e.nextElement();
	    r.relMove(dx,dy);
	}
	super.move(x,y);
    }

    protected void setInitPos(int nr) {
	x=nr*40;
	y=nr*40;
    }

}
