package netgui;

import java.awt.*;

public abstract class NetComponent  {

    protected static Color selectedColor=Color.blue;
    protected static Color foreground=Color.black;
    protected static Color foreground2=Color.white;

    protected boolean selected=false;
    protected int x; 
    protected int y;

    
    public void select() {
	selected=true;
    }
    public void deselect() {
	selected=false;
    }

    public boolean isSelected() {
	return selected;
    }

    public Dimension position() {
	return new Dimension(x,y);
    }

    public abstract void paintOn(Graphics g);

    abstract NetComponent touching(int x, int y) ;
    // Does (x,y) lie in the component or one of its sub-componets
    
    public boolean touches(int x, int y) {
	return touching(x,y) != null;
    }

    protected void setInitPos(int nr) {
	x=nr*40;
	y=nr*40;
    }

    protected void setFontSize(int size, Graphics g) {
	Font font=g.getFont();
	g.setFont(new Font(font.getName(), font.getStyle(), size));
    }
}
