package netgui;

import java.awt.Dimension;

public class Positioner {
    // Enforces a position for new domains and routers.

    protected static int rows=5; // The nr of domains per depth.
    protected static int cols=5; // The depth of the display in nr of domains.
    protected static int xoff=200; // Screen offset between domains of different depth.
    protected static int yoff=200;
    
    protected static int startx=450;
    protected static int starty=50;
    
    protected static double alpha=Math.PI/2; // The offset angle between routers on the same domain

    protected int[] fillPos= {0,0,0,0,0}; 

    public void put(Domain domain, int hopCount) {
	int x, y;
	int depth=hopCount/2; // not very smart.
	if(depth>4) {
	    System.err.println("Positioner: too deep network to display!");
	    return;
	}
	x=startx-depth*xoff;
	y=starty+fillPos[depth]*yoff;
	fillPos[depth]++;
	domain.move(x,y);
    }

    public void put(Router router, Domain dom) {
	int displayed=dom.routers();
	Dimension d=dom.position();
	double angle=displayed*alpha;
	int r=dom.radius();
	double x=d.width+r*Math.sin(angle); // Place them aroud the domain with the offset angle of alpha.
	double y=d.height+r*Math.cos(angle);
	router.move((int) x, (int) y); // Uses the move routine that keeps the router on the
    }

    public void put(Router router, int x, int y) {
	router.move(x,y); // Uses the move routine that keeps the router on the
    }

    public void put(EndUser user, Router accessR) {
	// Position it close to the access router.
	Dimension d=accessR.position(); // carries the pos of the router.
	int x=d.width;
	int y=d.height;
	x+=80;
	y+=80; // Position the customer south-east of the access router.
	user.absMove(x,y);
    }

}
