package node;

import clientserver.*;
import utils.ObjectQueue;

import java.net.*;
import java.io.*;

public abstract class ResultChannel implements Runnable {
    // Encapsulates the ProtocolObjectSenderReceiver which is connected to the home-app;
    // For clear separation of client (homeApp) and server 
    // (node) the interface is defined as abstract class.
    // I wanted it to be an 'interface' but this causes troubles with the methods
    // that are only callable by the package (sto and getQueue).

    abstract public void send(Result r);

    abstract public void send(String s, boolean last);

    abstract void stop(boolean informRegistry);

    abstract ObjectQueue getQueue();

    abstract public void run();


}
