package stat;

public class RunDistribution extends DiscreteDistribution{

    protected double[] probs; 

    public RunDistribution(int cats) {
	nrOfCategories=cats;
	probs=new double[cats];
	initProbs();
    }
   
//     public String toString() {
// 	StringBuffer buff=new StringBuffer();
// 	buff.append("RunDistribution with ");
// 	buff.append(nrOfCategories);
// 	buff.append(" categories\nwith equal probability: ");
// 	buff.append(prob);
// 	buff.append(".\n");
// 	return new String(buff);
//     }

    protected double internalGetProbFor(int category) {
	return probs[category];
    }

    
    protected void initProbs() {
	int last=nrOfCategories-1;
	probs[last]=0;
	for (int i=0; i<last; i++) {probs[i]=initProbFor(i+1);}
	probs[last]=1.0-sum();
    }

    protected double initProbFor(int cat) {
	// effective way to implement 1/c!-1/(c+1)!
	double divisor=1.0;
	for (int i=2; i< cat+2; i++ ) {
	    divisor*=i;
	}
	divisor=divisor/cat;
	return 1.0/divisor;
    }

    public static void main(String args[]) {
	RunDistribution r= new RunDistribution(6);
	System.out.println(r);
	System.out.println(r.isSane());
    }

}
