package stat;

public class TabulatedCount extends TabulatedDistribution{
    // This class is used by diverse tests. Occurences matching
    // certain conditions are counted.

    protected long total; // The total number of measurements, which are subject
    // to counting.

    public TabulatedCount(int cats) {
	super(new double[cats]);
	total=0;
	initWithZero();
    }

    public TabulatedCount(double[] c, long t) {
	super(c);
	total=t;
    }

//     public TabulatedCount(FormatedSingletonStream s,  long t) {
// 	// Convenient constructor.
// 	super(s);
// 	total=t;
//     }

    public long getTotal() {
	return total;
    }

    public void incCat(int cat) {
	table[cat]++;
	total++;
    }

    public int getCountOf(int category) {
	double d=getProbabilityFor(category);
	int ret=(int) d;
	if (d-ret != 0) {
	    System.err.println("Conversion problem! The values do not represent counting results!");
	    return 0;
	} 
	return ret;
    }

    public String toString() {
	StringBuffer buff=new StringBuffer();
	buff.append("TabulatedCount with ");
	buff.append(nrOfCategories);
	buff.append(" categories\n");
	buff.append("and a total of ");
	buff.append(total);
	buff.append(" measurements.\n");
		
	buff.append(super.toString());
	
	return new String(buff);
    }

    public boolean isSane() {
	return isPositive() && sumsUpCorrectlyTo((double) total);
    }

    protected void initWithZero() {
	for (int i=0;i<table.length ;i++) {
	    table[i]=0;
	}
    }

}
