package stat;

import java.util.*;

public class TabulatedDistribution extends DiscreteDistribution{

    protected double[] table;

    public TabulatedDistribution(double[] t) {
	stableInit(t);
    }

//     public TabulatedDistribution(FormatedSingletonStream s) {
// 	// Convenient constructor. Reads from file.
// 	stableInit(readDoubleArrayFromSingletons(s, 1000000)); // table size limited!
//     }

    protected double internalGetProbFor(int category) {
	return table[category];
    }

    protected void stableInit(double[] t) {
	if (t.length<1) {
	    System.err.println("TabulatedDistribution expects table size of at least 1!");
	    nrOfCategories=1;
	    table=new double[nrOfCategories];
	    table[0]=1.0;
	} else {
	    nrOfCategories=t.length;
	    table=t;
	}
    }

//     public static double[] readDoubleArrayFromSingletons(Singletons s, int max) {
// 	Vector v=new Vector();
// 	int i=0;
// 	while(s.intsAvailable()&&(i<max)) {
// 	    v.addElement(new Double(s.nextDouble()));
// 	    i++;
// 	}
// 	i=0;
// 	double[] t=new double[v.size()];
// 	for(Enumeration e=v.elements(); e.hasMoreElements(); i++) 
// 	    t[i]=((Double) e.nextElement()).doubleValue();
// 	return t;
//     }

}
